<?php

namespace Drupal\commerce_globalonepay\PluginForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\commerce_payment\PluginForm\PaymentGatewayFormBase;

/**
 * Implement new void form with required Reason field.
 */
class VoidForm extends PaymentGatewayFormBase {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form['#success_message'] = t('Payment voided.');

    // Add additional field required by GlobalOnePay system.
    $form['reason'] = [
      '#type' => 'textfield',
      '#title' => t('Reason'),
      '#description' => t('The reason for the void.'),
      '#default_value' => t('Wrong payment.'),
      '#required' => TRUE,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValue($form['#parents']);
    $reason = $values['reason'];

    /** @var \Drupal\commerce_payment\Entity\PaymentInterface $payment */
    $payment = $this->entity;
    /** @var \Drupal\commerce_payment\Plugin\Commerce\PaymentGateway\SupportsAuthorizationsInterface $payment_gateway_plugin */
    $payment_gateway_plugin = $this->plugin;

    $payment_gateway_plugin->voidPayment($payment, $reason);
  }

}
